#ifndef __FIBREBASE_H__
#define __FIBREBASE_H__

#pragma pack(1)


#define FILTER_TYPE_INCLUDE	0
#define FILTER_TYPE_EXCLUDE	1
#define FILTER_ACCESS_RW	0
#define FILTER_ACCESS_RO	1

typedef struct _FIBRE_VOL_HOST_FILTER
{
	BYTE    name[8];
	BYTE    mask[8];
	BYTE    type;		// FILTER_TYPE_INCLUDE / FILTER_TYPE_EXCLUDE
	BYTE    mode;		// FILTER_ACCESS_RW / FILTER_ACCESS_RO
	WORD    tag;		// unused
} sFIBRE_VOL_HOST_FILTER, *pFIBRE_VOL_HOST_FILTER;


typedef struct _FIBRE_VOL_HOST_FILTER_LIST
{
	BYTE total;
	BYTE res;			//unused
	sFIBRE_VOL_HOST_FILTER hostfilter[8]; // max 8 filters per volumeset
}sFIBRE_VOL_HOST_FILTER_LIST, *pFIBRE_VOL_HOST_FILTER_LIST;


typedef struct _FIBRE_HOST_WWNAME
{
	BYTE    name[8];	
	BYTE    flag;	// reserved
	char    nickname[23];
} sFIBRE_HOST_WWNAME, *pFIBRE_HOST_WWNAME;


typedef struct _FIBRE_HOST_WWNAME_LIST
{
	BYTE total;
	sFIBRE_HOST_WWNAME hostname[20];	// max 20 hostname
}sFIBRE_HOST_WWNAME_LIST, *pFIBRE_HOST_WWNAME_LIST;

typedef enum _FIBRE_CH_SPEED
{
	SPEED_AUTO,
	SPEED_1G,
	SPEED_2G,
	SPEED_4G,
	TOTAL_SPEED
}FIBRE_CH_SPEED;

typedef enum _FIBRE_TOPOLOGY
{
	TP_AUTO,
	TP_LOOP,
	TP_POINTPOINT,
	TP_FABRIC,
	TOTAL_TP
}FIBRE_TOPOLOGY;

typedef enum _FIBRE_LOOP_STATUS
{
	STATUS_ENABLED,
	STATUS_DISABLED,
	TOTAL_STATUS
}FIBRE_LOOP_STATUS;


typedef struct _FIBRE_CONFIG
{
	BYTE    wwpn[8];	// port name wwpn[0], wwpn[1] is fixed to 0x21, 0x00
	BYTE    speed;
	BYTE    topology;
	BYTE    loopid;
	BYTE    loopstatus;
} sFIBRE_CONFIG, *pFIBRE_CONFIG;


#pragma pack()

#endif


